(function($) {

//  Ensure at least 8 posts are available
var postCountMin = 8;
var postCount = $("#gijt_rotator > div").length;
$("#gijt_rotator div:first").addClass('gijt_post-to-copy');

while (postCount < postCountMin) {
    
		$("#gijt_rotator .gijt_post-to-copy:last").clone().appendTo("#gijt_rotator");
		
		$("#gijt_rotator .gijt_post-to-copy:last").removeClass('gijt_post-to-copy');
		
		$("#gijt_rotator .gijt_post-to-copy:last").next('#gijt_spoke').addClass('gijt_post-to-copy');
		
		if (postCount >= postCountMin) {
		    
		    break;
		}
		
		postCount += 1;
}



/********************
*
*       Options 
*
********************/
 
//  Set perspective
var gijtPerspective = 1200; 


//  Assign panel numbers
$(".gijt_panel").each(function(i) {
    
$(this).addClass("panelNumber" + (i+1));

});


//  Set & apply Stage width (auto height)
var gijtManualSWEntry = 1000;
var gijtManualStageWidth = gijtManualSWEntry + "px";

$('#stage').css( '-webkit-perspective', gijtPerspective + 'px').css('width',gijtManualStageWidth);

var gijtStageWidth = $('#stage').width();
var  gijtStageHght = 500;

 $('#stage, #gijt_stage_wrapper').css('height', gijtStageHght + 'px').css('margin-top', gijtStageHght/(gijtPerspective/45) + 'px');


//  Set rotator overall width 
var gijtrotatorSel = '#gijt_rotator'
var gijtRotatorWidth = 1000;

//  To account for side panels
var gijtRotNewWidth = 0.872;
var gijtRotWidthSetting = 'scale3d('+ gijtRotNewWidth + ',' + gijtRotNewWidth + ',' + gijtRotNewWidth + ')';



//  Scale the overall stage
function SetStageSize() {
    
    var gijtStageWidth = $('#stage').width();
    var gijtPgBdyWidth = $(window).width();
    var scaleTheStage = gijtPgBdyWidth / gijtStageWidth; 
    gijtNewStageHght = gijtStageHght*scaleTheStage;
 
    if (gijtPgBdyWidth <= (gijtRotatorWidth/*/.75*/)) {  
        
        //  When the scale amount is set using the stage width, change it to 'width: auto' to help center it. 
        $('#stage_scale').css('transform', 'scale('+ scaleTheStage + ')' ).css('width', 'auto');
        
        $('#gijt_stage_wrapper').css('height', gijtNewStageHght + 'px').css('margin-top', gijtNewStageHght/(gijtPerspective/45) + 'px');

    } else {
        
        $('#stage_scale').css('' );
        
        $('#gijt_stage_wrapper').css('');
    }
}
    
  
//  Set Post selector and width
var gijtPostSelector = '#gijt_rotator .gijt_panel';
var gijtPostWidth    = 1000;
var gijtPostBkgrnd   = 'linear-gradient(to bottom, #4c4c4c 0%,#595959 12%,#666666 25%,#474747 39%,#2c2c2c 50%,#000000 51%,#111111 60%,#2b2b2b 76%,#1c1c1c 91%,#131313 100%)';
  
//  Post Border Settings
var gijtPostBordWdth = '7px';
var gijtPostBordType = 'outset';
var gijtPostBordColr = '#222';
var gijtPostBordRad  =  '3px'

//  Set Rotator speed
var gijtRotatorSpeed = 'all 2.5s ease';  
  
//  Set autoplay speed
var gijtAutoPlaySpeed = 5000;
var delayAfterClick = gijtAutoPlaySpeed*2;

//  Differnt Button Designs
$("#gijt-button-wrap").addClass('dark-metal');  
 


/********************
*
*   Apply Settings 
*
********************/ 

//  Apply Rotator settings
$(gijtrotatorSel).css('transform', gijtRotWidthSetting ).css('transition', gijtRotatorSpeed );


$(window).load(function() {
    
    //  A slight delay accomadtes slower connections
    setTimeout(function() {
        
        SetStageSize();
        
        
    }, 500);
    
    startRotation();
});


$(window).resize(function() {

    //  A slight delay accomadtes slower connections
    setTimeout(function() {
        
        SetStageSize();
        
    }, 500);
});


//  Apply post settings
$(gijtPostSelector).css('height', gijtPostWidth/1.777777777777778).css('background', gijtPostBkgrnd).css('border', gijtPostBordWdth + ' ' + gijtPostBordType + ' ' + gijtPostBordColr).css('width', gijtPostWidth + 'px').css('border-radius',gijtPostBordRad );  

$('#stage_scale').css('opacity', '1');


/********************
*
*   Functions 
*
********************/ 

//  Auto Play
var gijtIntervalFn;
var intRestRunning = false;

function startRotation() {

    if (!intRestRunning) {

      gijtIntervalFn = window.setInterval(gijt_moveRight, gijtAutoPlaySpeed);
      
      intRestRunning = true;

  } 
}


function stopRotation() {

    clearInterval(gijtIntervalFn);
    
    intRestRunning = false;
}




$(gijtrotatorSel + ', #gijt-button-wrap').on({
    
    mouseenter: function(){
        
        stopRotation();
    },
    
    mouseleave: function(){
        
       startRotation();
    }
});
    
  
  
 $( window ).blur( function( e ) {
     
   stopRotation();
   
});

   
//  Movement
var rotateAmt = 0;
function gijt_moveLeft() {
    
   rotateAmt = rotateAmt -45;
  
  $(gijtrotatorSel).css('transform', 'rotatey(' + rotateAmt + 'deg )' + gijtRotWidthSetting );

}


function gijt_moveRight() {
    
rotateAmt = rotateAmt +45;
 
  $(gijtrotatorSel).stop(true,true).css('transform', 'rotatey(' + rotateAmt + 'deg )' + gijtRotWidthSetting);

} 
 

//  Buttons
$(document).on('click', '.gijt-btnL', function() {
    
    stopRotation();
    
    gijt_moveLeft();
    
    setTimeout(startRotation(), delayAfterClick);

});


$(document).on('click', '.gijt-btnR', function() {
    
    stopRotation();
    
    gijt_moveRight();
    
    setTimeout(startRotation(), delayAfterClick);
    
});    


    
/********************
* 
*     Touch Control 
* 
* This was slightly modified code 
* to create left and right movement. 
* Core code is from user "mddw" at 
* https://stackoverflow.com/questions/12428433/jquery-touch-swipe-event-no-jquery-mobile
********************/


$.fn.tactile = function(swipe) {
    
    return this.each(function() {
        
        var $this = $(this),
        isTouching = false,
        
        start;                                
        
        $this.on('touchstart', startGesture);       
        
        function startGesture() {
          
            if (event.touches.length == 1) {
                
              start = event.touches[0].pageX;
              
              isTouching = true;
              
              $this.on('touchmove', gesture);
              
            }
        }
        
        function endGesture() {
          
            $this.off('touchmove');
            
            isTouching = false;
            
            start = null;
            
        } 
        
        function gesture() {
          
            if(isTouching) {
                
                var actuel = event.touches[0].pageX,
                
                delta = start - actuel;
                
                if (Math.abs(delta) >= 30) {     // this '30' is the length of the swipe
                
                    if (delta > 0) {
                        
                        swipe.left();

                    } else {

                        swipe.right();

                    }   

                    endGesture();

                } 
            }
            
        event.preventDefault(); 
    
        }
    });
};
 

$('#gijt_rotator .gijt_panel').tactile({
    
    left: function() {
        
        stopRotation();
        
        gijt_moveLeft();
        
        setTimeout(startRotation, delayAfterClick);
        
    },
    
    right: function() {
    
        stopRotation();
        
        gijt_moveRight();
        
        setTimeout(startRotation, delayAfterClick);
    
    }
});


})( jQuery );