<?php

function create_posttype() {
        
    register_post_type( 'gi_jumboslides',
    // CPT Options
    
    array(
     'labels' => array(
      'name' => __( 'GI JumboSlides' ),
     'singular_name' => __( 'GI JumboSlide' )
      ),
      'public' => true,
      'has_archive' => false,
      'rewrite' => array('slug' => 'gi_jumboslides'),
    )
    );
}

//    Hooking up our function to theme setup
add_action( 'init', 'create_posttype' );



function cw_post_type_gi_jumboslides() {

    $supports = array(
    'title', // post title
    'editor', // post content
    'page-attributes' ,
    'author', // post author
    'thumbnail', // featured images
    'excerpt', // post excerpt
    'custom-fields', // custom fields
    'comments', // post comments
    'revisions', // post revisions
    'post-formats', // post formats
    );
    
    $labels = array(
    'name' => _x('GI JumboSlides', 'plural'),
    'singular_name' => _x('GI JumboSlide', 'singular'),
    'menu_name' => _x('GI JumboSlides', 'admin menu'),
    'name_admin_bar' => _x('GI JumboSlides', 'admin bar'),
    'add_new' => _x('Add New', 'add new'),
    'add_new_item' => __('Add New JumboSlide'),
    'new_item' => __('New JumboSlide'),
    'edit_item' => __('Edit GI JumboSlides'),
    'view_item' => __('View your GI JumboSlides'),
    'all_items' => __('All GI JumboSlides'),
    'search_items' => __('Search GI JumboSlides'),
    'not_found' => __('No JumboSlides found.'),
    );
    
    $args = array(
    'supports' => $supports,
    'labels' => $labels,
    'public' => true,
    'query_var' => true,
    'rewrite' => array('slug' => 'gi_jumboslides'),
    'has_archive' => true,
    'hierarchical' => false,
    );
    register_post_type('gi_jumboslides', $args);
}
add_action('init', 'cw_post_type_gi_jumboslides');



add_filter('pre_get_posts', 'modify_pre_query_request');
function modify_pre_query_request($query){
    if ($query->is_main_query()){
        if ($query->is_tax){
            $post_type = get_query_var('post_type');
            if (!$post_type){
                $post_type = array( 'post', 'gi_jumboslides' );
                $query->set('post_type', $post_type);
            }
        }
    }
}



//    Make sure featured images are enabled
add_theme_support( 'post-thumbnails' );

//    Add featured image sizes
add_image_size( 'featured-large', 640, 294, true ); // width, height, crop
add_image_size( 'featured-small', 320, 147, true );

//    Add other useful image sizes for use through Add Media modal
add_image_size( 'medium-width', 480 );
add_image_size( 'medium-height', 9999, 480 );
add_image_size( 'medium-something', 480, 480 );



//    Register the three useful image sizes for use in Add Media modal
add_filter( 'image_size_names_choose', 'wpshout_custom_sizes' );
function wpshout_custom_sizes( $sizes ) {
    return array_merge( $sizes, array(
        'medium-width' => __( 'Medium Width' ),
        'medium-height' => __( 'Medium Height' ),
        'medium-something' => __( 'Medium Something' ),
    ) );
}



//    Remove all non-essential metaboxes from teh  jumbotron post type.
function my_remove_meta_boxes() {
    $remove_for = 'gi_jumboslides';
	if ( is_admin ) {
		remove_meta_box( 'linktargetdiv', $remove_for, 'normal' );
		remove_meta_box( 'linkxfndiv', $remove_for, 'normal' );
		remove_meta_box( 'linkadvanceddiv', $remove_for, 'normal' );
		remove_meta_box( 'postexcerpt', $remove_for, 'normal' );
		remove_meta_box( 'trackbacksdiv', $remove_for, 'normal' );
		remove_meta_box( 'postcustom', $remove_for, 'normal' );
		remove_meta_box( 'commentstatusdiv', $remove_for, 'normal' );
		remove_meta_box( 'commentsdiv', $remove_for, 'normal' );
		remove_meta_box( 'authordiv', $remove_for, 'normal' );
		remove_meta_box( 'sqpt-meta-tags', $remove_for, 'normal' );
		remove_meta_box( 'sharing_meta', $remove_for, 'normal' );
		remove_meta_box( 'display-post-shortcode', $remove_for, 'normal');
	}
}
add_action( 'do_meta_boxes', 'my_remove_meta_boxes' );


?>